c 	 Copyright 2006 Villy G. Madsen

	 Implicit none
	 integer*4 efn
	 integer*4 GetPid
	 integer*4 InAdr(2)
	 integer*4 RtnPid
	 integer*4 CurCpuTime
	 integer*4 RtnCode,RtnCode1
	 integer*4 RtnAddr(2)
	 integer*4 count,SleepCt,Interval
	 integer*4 total
	 integer*4 I, FirstFree
	 integer*4 TimerVal(2)
	 integer*4 offset
	 integer*4 Sys$SeTimr
	 integer*4 Sys$WaitFr
	 integer*4 Sys$BinTim
	 integer*4 SYS$CRMPSC
	 integer*4 SYS$TRNLNM
	 Integer*4 sys$getjpiw
	 integer*4 sys$crelnm
	 integer*4 OTS$CVT_TU_L
	 integer*4 OTS$CVT_L_TU
	 Integer*4 MinVal,Flags
	 integer*4 Lib$Init_Timer
	 integer*4 Lib$Stat_Timer

	 integer*2 MemoryMap(256)
	 common /memory/MemoryMap
	 integer*4 vbn
	 include '($JPIDEF)'
	 include '($SSDEF)/list'
	 include '($PSLDEF)'
	 include '($SECDEF)'
	 include '($LNMDEF)'
c	 include '($SYSSRVNAM)'
	 integer*4 Status
	 external Lib$Init_timer
	 external Lib$Stat_Timer
	 external Sys$SeTimr
	 external Sys$WaitFr
	 external SYS$CRMPSC
	 external sys$trnlnm
	 external sys$crelnm
	 structure /ItemListRec/
	  union
	    map
		integer*2 BufLen,ItemCode
		integer*4 Bufadr, RetAdr
	    end map
	    map
                integer*4 end_list
	    end map
          end union
	 end structure

	 structure /PrcInfo/
	   integer*4 Pid
	   integer*4 CpuTime
	   logical*1 Updated
	 end structure

	 structure /IosBlkRec/
	   integer*4 sts, Zeroed
	 end structure
	 Character*4 ThrottleStr
	 Integer*4 StrLen
	 Integer*2 Name_len,Name_Code
	 Integer*4 Name_Addr, Ret_Addr /0/, End_list /0/
	 common /list/ Name_len,
	1	       Name_Code,
	1              Name_Addr,
	1	       Ret_Addr,
	1	       End_List


	 record /ItemListRec/ ItemList(2)
	 record /IosBlkRec/ IOSB
	 record /PrcInfo/ PrcList(1000)
	 parameter IO780$AL_IOBASE = Z'20000000'
	 parameter IO780$AL_UB0SP  = Z'20100000'
	 parameter IO650$AL_QB0SP  = Z'20000000'
	 parameter DN11_CSR        = O'015200'

	 ItemList(1).ItemCode = JPI$_CPUTim	
	 ItemList(1).Buflen = 4
	 ItemList(1).BufAdr = %loc(CurCpuTime)

	 ItemList(2).ItemCode = JPI$_Pid	
	 ItemList(2).Buflen = 4
	 ItemList(2).BufAdr = %loc(RtnPid)

	 do I = 1,1000			! initialize the table used to store 
           PrcList(I).Pid = -1		! the process information
	   PrcList(I).CpuTime = 0
	   PrcList(I).Updated = .false.
	 end do
	 RtnCode = Sys$BinTim('0000 00:00:10.00',TimerVal)  !
	 InAdr(1) = %Loc(MemoryMap(1))
	 InAdr(2) = %Loc(MemoryMap(256))
	 vbn = ((IO650$AL_QB0SP + DN11_CSR) .and. Z'3FFFFFFF') / 512
	 Offset = (((IO650$AL_QB0SP + DN11_CSR) .and. Z'3FFFFFFF')
	1 - (vbn * 512))/2 + 1
	 RtnCode = SYS$CRMPSC(InAdr,RtnAddr,%val(PSL$C_USER)
	1		     ,%val(SEC$M_PFNMAP + SEC$M_WRT)
	1                    ,,,,,%val(1),%val(vbn)
	1		     ,,,)
	 Print*,'Mapped to VBN ',vbn,'  return code was ',RtnCode
	 if (InAdr(1) .ne. RtnAddr(1)) then
            Print*, 'Psect Alightment Error, or insufficient privilege'
	    print*,InAdr(1),'  ',RtnAddr(1)
	    print*,'did you forget to use the link options file'
	    stop
	 end if
	 PrcList(1).Pid = -1

	 SleepCt = 1001
	 Print*,'Writing ',SleepCt,' to offset ',Offset
	 MemoryMap(Offset) = SleepCt
	 		! set the sampling time to 2 seconds
	 RtnCode = Sys$BinTim('0000 00:00:02.00',TimerVal)
	 Interval = 2
	! repeat forever
1000	 continue
	 Name_len = 4
	 Name_code = (LNM$_STRING)
	 Name_addr = %loc(ThrottleStr)
	 Ret_Addr = %loc(StrLen)
	 ThrottleStr = ' '
	 Status = Sys$trnlnm(,'LNM$SYSTEM_TABLE','THROTTLEMIN',,Name_Len)
         Print*,'ThrottleStr =>',ThrottleStr
	 Flags=1
	 Status = OTS$CVT_TU_L(ThrottleStr(1:Strlen),MinVal,,flags)
	 Print*,'MinVal => ',MinVal

	 GetPid = -1
         count = 0
	 total = 0
	 efn=0
	 RtnCode1 = SS$_Normal
         IOSB.sts = SS$_Normal

	 ! The following code will loop through the list of processes
	 ! collecting process cpu utilization data.
	 do while ((RtnCode1 .eq. SS$_Normal)
	1	 .and. (IOSB.sts .eq. SS$_Normal))
	   RtnCode1 = SYS$GetJPIW(,GetPid,,ItemList,IOSB,,)
	   I = 0
           FirstFree = 0
		! The pid of the sampled process is in RtnPid
		! Scan through the list of entries that we have
		! already collected data for looking for a match
		! If we find an entry with pid=0 then save that
		! entry number to use (if we don't find a match
		! for this process)

		! If the pid value is -1 - this implies that we have hit
		! the high water mark for the pids - no point in going
		! any further	
	     
	   If (RtnCode1 .ne. SS$_NOMOREPROC) then
             do while ((PrcList(I).Pid .NE. RtnPid) .and. 
	1              (PrcList(I).Pid .GE. 0))
	       I = I + 1
	       If ((PrcList(I).Pid .le. 0) .and. 
	1          (FirstFree .eq. 0)) FirstFree = I
             end do
	     if (PrcList(I).pid .eq. -1) then	
		! if we get here, then we have not been able to find
		! a match in the pid table for the process 
		! in other words - this is a new process
	       Print*,' Adding entry at ',FirstFree
               PrcList(FirstFree).pid = 0
	       PrcList(I+1).pid = -1
	       I = FirstFree
	     end if
	     if (PrcList(I).Pid .ne. 0) then
	       ! if we have a match tally the cpu time (in 10ms increments)
	       total = total + (CurCpuTime - PrcList(I).CpuTime)
	       count = count + 1
	     else
	        PrcList(I).Pid = RtnPid	! adding new entry info
	     end if
	     ! Update the entry with the new information
	     PrcList(I).CpuTime = CurCpuTime
	     PrcList(I).Updated = .True.
	   end if  
	 end do
  	 i = 1
		! clean up the entries for anything that wasn't updated
		! - in other words, the process has disappeared
         do while ((PrcList(I).pid .ne. -1) .and. (I .lt. 1000))
           if (.not. PrcList(I).Updated) then
              PrcList(I).Pid = 0
              PrcList(I).CpuTime = 0
              PrcList(I).UpDated = .false.	! yeah - redundant
	   end if
           i = i + 1
         end do
		! now we determine how to adjust our sleep time
		! values of 0 or >1000 turn off the sleep cycles in the 
		! simulator...
		! otherwise the sleep ct tells the simulator how many
		! blocks of instructions to execute before sleeping for
		! 1 millisecond.  The number of instructions in the block
		! is hardcoded into VAX_CPU.c
		! note the effects are based upon %
		! i.e. 1 to 2 has a 100% difference
		! 100 to 101 has a 1% difference (more or less)

         I = Max(1,SleepCt /4) ! calculate an increment to use
	 if (total .GT. (Interval * 80)) then	! throttle up if we are
            If (SleepCt .LT. 100) then		! running at > 80% cpu
	      if (Total .gt. (Interval * 90)) then
                 SleepCt = SleepCT + Max(I,25)
	      else
                SleepCt = SleepCt + Max(I,10)		! ramp up a little faster
	      end if 
            else
	      SleepCt = Min(SleepCt + I,1001)
	    end if
	 end if 
	 If (total .LT. (Interval * 25)) then	! ramp down if are at less
            SleepCt = Max(SleepCt - I,MinVal)	! then 25% cpu
	 end if
	 If ((SleepCt.gt. 1001) .or. (SleepCt .lt. 0)) then
           Print*,'Error in SleepCt ',SleepCt
	   SleepCt = 1001
	 end if 
	 Name_Len = 4
	 Name_Code = (LNM$_STRING)
	 NAME_ADDR = %loc(ThrottleStr)
	 Status = OTS$CVT_L_TU(SleepCt,ThrottleStr,,)
	 Status = Sys$CreLnm(,'LNM$SYSTEM_TABLE','THROTTLECUR',,Name_Len)
c	 print*,' loading ',Sleepct
	 MemoryMap(Offset) = SleepCt			! load the new throttle setting
	 RtnCode = Sys$Setimr(0,TimerVal,,,)	! sleep for interval seconds
	 RtnCode = Sys$WaitFr(0)
c	 print*,'count =>',count,'  total =>',total,' SleepCt =>',SleepCt
c	 Print*,'Writing ',SleepCt,' to offset ',Offset,' read ',
c	1 MemoryMap(Offset)
	 goto 1000
	 end
